SystemOrganization addCategory: #'Mendel-Model'!

!String methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:36'!
splitCamelCase
	| result currentString |
	result := OrderedCollection new.
	currentString := WriteStream on:(String new).
	self doWithIndex:[:char :idx |
		(char isUppercase and:[idx > 1]) 
			ifTrue:[
				result add: (currentString contents).
				currentString := WriteStream on:(String new).
				currentString nextPut: char]
			ifFalse:[
				currentString nextPut: char]].
	"Do not forget the last token"
	result add: (currentString contents).
	^result 
	! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:28'!
mendelAddCallsTo: aSet
	self messages
		do: [ :message | 
			aSet add:(CallsTrait value: message)]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:12'!
mendelAddImplementsMessagesTo: aSet
	aSet add:(ImplementsMessageTrait value: self selector)	! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:19'!
mendelAddInProtocolTo: aSet
	aSet add:(InProtocolTrait value: (self category))! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:12'!
mendelAddKeywordsTo: aSet
		(self selector asString splitCamelCase)
			do: [:keyword | 
				(keyword size >= 4) 
					ifTrue: [aSet add: (KeywordTrait value: keyword)]]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:21'!
mendelAddRefersClassesTo: aSet
	self literals
		do: [ :literal | 
			(literal isKindOf: Association)
				ifTrue: [ 
					(literal value isKindOf: ClassDescription)
						ifTrue: [ 
							(literal value ~= self methodClass)
								ifTrue: [ aSet add: (RefersClassTrait value: literal value) ] ] ] ]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:29'!
mendelTraits
	| theTraits |
	theTraits := Set new.
	self mendelAddKeywordsTo: theTraits.
	self mendelAddImplementsMessagesTo: theTraits.
	self mendelAddInProtocolTo: theTraits.
	self mendelAddRefersClassesTo: theTraits.
	self mendelAddCallsTo: theTraits.
	^theTraits! !

Object subclass: #AbstractEntityTrait
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!AbstractEntityTrait class methodsFor: 'instance creation' stamp: 'AndyKellens 6/15/2012 14:40'!
value: aValue 
	^super new value: aValue! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/15/2012 14:41'!
= anEntityTrait
	^self class = anEntityTrait class and:[value = (anEntityTrait value)]! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/15/2012 14:41'!
hash 
	^value hash! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isCallsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isHierarchyTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isImplementsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isKeywordTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isProtocolTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isRefersClassTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isUnderstandsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'printing' stamp: 'AndyKellens 6/15/2012 15:42'!
printOn: aStream
	aStream nextPutAll: (self traitName).
	aStream nextPutAll: '>>'.
	value printOn: aStream! !

!AbstractEntityTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:42'!
traitName
	self subclassResponsibility ! !

!AbstractEntityTrait methodsFor: 'accessing' stamp: 'AndyKellens 6/15/2012 14:40'!
value 
	^value! !

!AbstractEntityTrait methodsFor: 'accessing' stamp: 'AndyKellens 6/15/2012 14:40'!
value: aValue 
	value := aValue! !

AbstractEntityTrait subclass: #CallsTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!CallsTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isCallsTrait 
	^true! !

!CallsTrait methodsFor: 'private' stamp: 'AndyKellens 6/18/2012 10:22'!
traitName
	^'Calls'! !

AbstractEntityTrait subclass: #ImplementsMessageTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!ImplementsMessageTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isImplementsTrait 
	^true! !

!ImplementsMessageTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:51'!
traitName
	^'Implements'! !

AbstractEntityTrait subclass: #InHierarchyTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!InHierarchyTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isHierarchyTrait 
	^true! !

!InHierarchyTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Hierarchy'! !

AbstractEntityTrait subclass: #InProtocolTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!InProtocolTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isProtocolTrait 
	^true! !

!InProtocolTrait methodsFor: 'private' stamp: 'AndyKellens 6/18/2012 10:18'!
traitName
	^'Protocol'! !

AbstractEntityTrait subclass: #KeywordTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!KeywordTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isKeywordTrait 
	^true! !

!KeywordTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:45'!
traitName
	^'Keyword'! !

AbstractEntityTrait subclass: #RefersClassTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!RefersClassTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:58'!
isRefersClassTrait 
	^true! !

!RefersClassTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Refers'! !

AbstractEntityTrait subclass: #UnderstandsMessageTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!UnderstandsMessageTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:58'!
isUnderstandsTrait 
	^true! !

!UnderstandsMessageTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Understands'! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:39'!
mendelAddImplementsMessagesTo: aSet
	self selectors do:[:selector | aSet add:(ImplementsMessageTrait value: selector)]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 13:40'!
mendelAddInHierarchyTo: aSet
	| superclasses |
	superclasses := self allSuperclasses copyWithoutAll: {Object . ProtoObject}.
	aSet add:(InHierarchyTrait value: self).
	superclasses do: [:theSuperClass | aSet add:(InHierarchyTrait value: theSuperClass)]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:36'!
mendelAddKeywordsTo: aSet
		(self name asString splitCamelCase)
			do: [:keyword | 
				(keyword size > 3) 
					ifTrue: [aSet add: (KeywordTrait value: keyword)]]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 13:32'!
mendelAddUnderstandsMessagesTo: aSet
	| superclasses  |

	superclasses := self allSuperclasses copyWithoutAll: {Object . ProtoObject}.
	superclasses
		do: [:each | each selectors do: [:selector | aSet add: (UnderstandsMessageTrait value: selector)]]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:37'!
mendelFamily
	"The family of the class are all my siblings and their subclasses"
	"If the class is abstract, then only consider abstract classes"
	"Classes without methods are considered to be concrete"
	| theFamily isAbstract |
	theFamily := Set new.
	isAbstract := self selectors ifEmpty: [false] ifNotEmpty:[self isAbstractClass].
	(self superclass ~= Object) 
		ifTrue:[
			| siblings |
			siblings := self superclass subclasses copyWithout: self.
			theFamily addAll:siblings.
			siblings do:[:sibling | theFamily addAll: (sibling subclasses)]].
	^theFamily select:[:each | each isAbstractClass = isAbstract]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:07'!
mendelTraits
	| theTraits |
	theTraits := Set new.
	self mendelAddKeywordsTo: theTraits.
	self mendelAddImplementsMessagesTo: theTraits.
	self mendelAddUnderstandsMessagesTo: theTraits.
	self mendelAddInHierarchyTo: theTraits.
	^theTraits! !
